Index: TOOLS/WATER_BUDGET/ATM_waterbudget.py
===================================================================
--- TOOLS/WATER_BUDGET/ATM_waterbudget.py	(revision 6620)
+++ TOOLS/WATER_BUDGET/ATM_waterbudget.py	(revision 6647)
@@ -34,8 +34,10 @@
     raise Exception ( "Minimum Python version is 3.8" )
 
-## Import local module
+## Import local modules
 import WaterUtils as wu
 import libIGCM_sys
 import nemo, lmdz
+
+from WaterUtils import VarInt, Rho, Ra, Grav, ICE_rho_ice, ICE_rho_sno, OCE_rho_liq, ATM_rho, SRF_rho, RUN_rho, ICE_rho_pnd, YearLength
 
 ## Creates parser for reading .ini input file
@@ -47,6 +49,7 @@
 ## ---------------------
 ATM=None ; ATM_HIS='latlon' ; SRF_HIS='latlon' ; RUN_HIS='latlon' ; ORCA=None ; NEMO=None ; OCE_relax=False
-OCE_icb=False ; Coupled=False ; Routing=None
+OCE_icb=False ; Coupled=False ; Routing=None ; TestInterp=None
 TarRestartPeriod_beg=None ; TarRestartPeriod_end=None ; Comment=None ; Period=None ; Title=None
+YearBegin=None ; YearEnd=None ; DateBegin=None ; DateEnd=None
 
 ##
@@ -66,4 +69,11 @@
 tar_restart_end_RUN=None ; tar_restart_end_OCE=None ; tar_restart_end_ICE=None
 ContinueOnError=False ; ErrorCount=0 ; SortIco = False
+
+##
+## Precision of history file reading
+## ---------------------------------
+# Default is float (full precision). Degrade the precision by using np.float32
+# Restart file are always read at the full precision
+readPrec=float
 
 ## Read command line arguments
@@ -138,4 +148,13 @@
 print ( f'\nConfig file readed : {IniFile} ' )
 
+##
+## Reading prec
+if wu.unDefined ( 'readPrec' )  :
+    readPrec = np.float64
+else :
+    if readPrec in ["float", "float64", "r8", "double", "<class 'float'>"         ] : readPrec = float
+    if readPrec in [         "float32", "r4", "single", "<class 'numpy.float32'>" ] : readPrec = np.float32
+    if readPrec in [         "float16", "r2", "half"  , "<class 'numpy.float16'>" ] : readPrec = np.float16
+    
 ## Some physical constants
 ## =======================
@@ -155,8 +174,8 @@
 if not 'Files' in config.keys () : config['Files'] = {}
 
-config['Physics'] = { 'Ra':Ra, 'Grav':Grav, 'ICE_rho_ice':ICE_rho_ice, 'ICE_rho_sno':ICE_rho_sno,
-                      'OCE_rho_liq':OCE_rho_liq, 'ATM_rho':ATM_rho, 'SRF_rho':SRF_rho, 'RUN_rho':RUN_rho}
-
-config['Config'] = { 'ContinueOnError':ContinueOnError, 'SortIco':SortIco }
+config['Physics'] = { 'Ra':str(Ra), 'Grav':str(Grav), 'ICE_rho_ice':str(ICE_rho_ice), 'ICE_rho_sno':str(ICE_rho_sno),
+                      'OCE_rho_liq':str(OCE_rho_liq), 'ATM_rho':str(ATM_rho), 'SRF_rho':str(SRF_rho), 'RUN_rho':str(RUN_rho)}
+
+config['Config'] = { 'ContinueOnError':str(ContinueOnError), 'SortIco':str(SortIco), 'TestInterp':str(TestInterp), 'readPrec':str(readPrec) }
 
 ## --------------------------
@@ -176,16 +195,17 @@
 if wu.unDefined ( 'DateBegin' ) :
     DateBegin = f'{YearBegin}0101'
-    config['Experiment']['DateBegin'] = DateBegin
+    config['Experiment']['DateBegin'] = str(DateBegin)
 else :
-    YearBegin, MonthBegin, DayBegin = wu.DateSplit ( DateBegin )
-    DateBegin = wu.FormatToGregorian ( DateBegin)
-    config['Experiment']['YearBegin'] = YearBegin
+    YearBegin, MonthBegin, DayBegin = wu.SplitDate ( DateBegin )
+    DateBegin = wu.FormatToGregorian (DateBegin)
+    config['Experiment']['YearBegin'] = str(YearBegin)
 
 if wu.unDefined ( 'DateEnd' )   :
     DateEnd   = f'{YearEnd}1231'
-    config['Experiment']['DateEnd']   = DateEnd
+    config['Experiment']['DateEnd'] = str(DateEnd)
 else :
-    YearEnd, MonthEnd, DayEnd = wu.DateSplit ( DateEnd )
-    DateEnd   = wu.FormatToGregorian ( DateEnd)
+    YearEnd, MonthEnd, DayEnd = wu.SplitDate ( DateEnd )
+    DateEnd   = wu.FormatToGregorian (DateEnd)
+    config['Experiment']['DateEnd'] = str(DateEnd)
 
 if wu.unDefined ( 'PackFrequency' ) :
@@ -200,5 +220,12 @@
 ## Output file with water budget diagnostics
 ## -----------------------------------------
-if wu.unDefined ( 'FileOut' ) : FileOut = f'ATM_waterbudget_{JobName}_{DateBegin}_{DateEnd}.out'
+if wu.unDefined ( 'FileOut' ) :
+    FileOut = f'ATM_waterbudget_{JobName}_{YearBegin}_{YearEnd}'
+    if ICO : 
+        if ATM_HIS == 'latlon' : FileOut = f'{FileOut}_LATLON'
+        if ATM_HIS == 'ico'    : FileOut = f'{FileOut}_ICO'
+    if readPrec == np.float32  : FileOut = f'{FileOut}_float32'
+    FileOut = f'{FileOut}.out'
+
 config['Files']['FileOut'] = FileOut
 
@@ -207,4 +234,9 @@
 ## Useful functions
 ## ----------------
+if readPrec == float :
+    def rprec (tab) : return tab
+else : 
+    def rprec (tab) : return tab.astype(readPrec).astype(float)
+    
 def kg2Sv    (val, rho=ATM_rho) :
     '''From kg to Sverdrup'''
@@ -216,5 +248,5 @@
 
 def var2prt (var, small=False, rho=ATM_rho) :
-    if small :  return var , kg2Sv(var, rho=rho)*1000., kg2myear(var, rho=rho)*100#
+    if small :  return var , kg2Sv(var, rho=rho)*1000., kg2myear(var, rho=rho)*1000
     else     :  return var , kg2Sv(var, rho=rho)      , kg2myear(var, rho=rho)
 
@@ -236,5 +268,29 @@
     f_out.flush ()
     return None
-    
+
+echo ( f'{ContinueOnError = }' )
+echo ( f'{SortIco         = }' )
+echo ( f'{readPrec        = }' )
+
+echo ( f'{JobName         = }' )
+echo ( f'{ConfigCard      = }' )
+echo ( f'{libIGCM         = }' )     
+echo ( f'{User            = }' )       
+echo ( f'{Group           = }' )       
+echo ( f'{Freq            = }' )       
+echo ( f'{YearBegin       = }' )     
+echo ( f'{YearEnd         = }' )     
+echo ( f'{DateBegin       = }' )
+echo ( f'{DateEnd         = }' )
+echo ( f'{PackFrequency   = }' ) 
+echo ( f'{ATM             = }' )       
+echo ( f'{Routing         = }' )       
+echo ( f'{ORCA            = }' )      
+echo ( f'{NEMO            = }' )      
+echo ( f'{Coupled         = }' )      
+echo ( f'{ATM_HIS         = }' )      
+echo ( f'{SRF_HIS         = }' )      
+echo ( f'{RUN_HIS         = }' )      
+
 ## Set libIGCM directories
 ## -----------------------
@@ -266,7 +322,7 @@
 
 echo (' ')
-echo ( f'JobName    : {JobName}'   )
-echo ( f'Comment    : {Comment}'   )
-echo ( f'TmpDir     : {TmpDir}'    )
+echo ( f'JobName     : {JobName}'    )
+echo ( f'Comment     : {Comment}'    )
+echo ( f'TmpDir      : {TmpDir}'     )
 echo ( f'FileDir     : {FileDir}'    )
 echo ( f'FileDirOCE  : {FileDirOCE}' )
@@ -598,76 +654,67 @@
 # ATM grid with cell surfaces
 if LMDZ :
-    ATM_lat  = lmdz.geo2point (   d_ATM_his ['lat']+0*d_ATM_his ['lon'], dim1D='cell_latlon' )
-    ATM_lon  = lmdz.geo2point ( 0*d_ATM_his ['lat']+  d_ATM_his ['lon'], dim1D='cell_latlon' )
-    ATM_aire = lmdz.geo2point ( d_ATM_his ['aire']     [0], cumulPoles=True, dim1D='cell_latlon' )
-    ATM_fter = lmdz.geo2point ( d_ATM_his ['fract_ter'][0], dim1D='cell_latlon' )
-    ATM_foce = lmdz.geo2point ( d_ATM_his ['fract_oce'][0], dim1D='cell_latlon' )
-    ATM_fsic = lmdz.geo2point ( d_ATM_his ['fract_sic'][0], dim1D='cell_latlon' )
-    ATM_flic = lmdz.geo2point ( d_ATM_his ['fract_lic'][0], dim1D='cell_latlon' )
-    SRF_lat  = lmdz.geo2point (   d_SRF_his ['lat']+0*d_SRF_his ['lon'], dim1D='cell_latlon' )
-    SRF_lon  = lmdz.geo2point ( 0*d_SRF_his ['lat']+  d_SRF_his ['lon'], dim1D='cell_latlon' )
-    SRF_aire      = lmdz.geo2point ( d_SRF_his ['Areas'] * d_SRF_his ['Contfrac'], dim1D='cell_latlonl', cumulPoles=True )
-    SRF_areas     = lmdz.geo2point ( d_SRF_his ['Areas'],  dim1D='cell_latlonl', cumulPoles=True )
-    SRF_contfrac  = lmdz.geo2point ( d_SRF_his ['Contfrac'], dim1D='cell_latlonl' )
-
-    #SRF_res_aire = SRF_aire
-    
+    echo ('ATM grid with cell surfaces : LMDZ')
+    ATM_lat       = lmdz.geo2point (   rprec (d_ATM_his ['lat'])+0*rprec (d_ATM_his ['lon']), dim1D='cell' )
+    ATM_lon       = lmdz.geo2point ( 0*rprec (d_ATM_his ['lat'])+  rprec (d_ATM_his ['lon']), dim1D='cell' )
+    ATM_aire      = lmdz.geo2point ( rprec (d_ATM_his ['aire'] )    [0], cumulPoles=True, dim1D='cell' )
+    ATM_fter      = lmdz.geo2point ( rprec (d_ATM_his ['fract_ter'][0]), dim1D='cell' )
+    ATM_foce      = lmdz.geo2point ( rprec (d_ATM_his ['fract_oce'][0]), dim1D='cell' )
+    ATM_fsic      = lmdz.geo2point ( rprec (d_ATM_his ['fract_sic'][0]), dim1D='cell' )
+    ATM_flic      = lmdz.geo2point ( rprec (d_ATM_his ['fract_lic'][0]), dim1D='cell' )
+    SRF_lat       = lmdz.geo2point (   rprec (d_SRF_his ['lat'])+0*rprec (d_SRF_his ['lon']), dim1D='cell' )
+    SRF_lon       = lmdz.geo2point ( 0*rprec (d_SRF_his ['lat'])+  rprec (d_SRF_his ['lon']), dim1D='cell' )
+    SRF_aire      = lmdz.geo2point ( rprec (d_SRF_his ['Areas']) * rprec (d_SRF_his ['Contfrac']), dim1D='cell', cumulPoles=True )
+    SRF_areas     = lmdz.geo2point ( rprec (d_SRF_his ['Areas'])  ,  dim1D='cell', cumulPoles=True )
+    SRF_contfrac  = lmdz.geo2point ( rprec (d_SRF_his ['Contfrac']), dim1D='cell' )
+
 if ICO :
     if ATM_HIS == 'latlon' :
-        jpja, jpia = d_ATM_his['aire'][0].shape
-        if wu.unDefined ( 'file_ATM_aire' ) : 
-            file_ATM_aire = os.path.join ( R_IN, 'ATM', 'GRID', f'aire_{ATM}_to_{jpia}x{jpja}.nc' )
-            config['Files']['file_ATM_aire'] = file_ATM_aire
-        echo ( f'Aire sur grille reguliere : {file_ATM_aire = }' )
-        d_ATM_aire = xr.open_dataset ( file_ATM_aire, decode_times=False ).squeeze()
-        try :
-            ATM_lat  = lmdz.geo2point (   d_ATM_his ['lat']+0*d_ATM_his ['lon'], dim1D='cell_latlon' )
-            ATM_lon  = lmdz.geo2point ( 0*d_ATM_his ['lat']+  d_ATM_his ['lon'], dim1D='cell_latlon' )
-        except :
-            ATM_lat  = lmdz.geo2point (   d_ATM_his ['lat_dom_out']+0*d_ATM_his ['lon_dom_out'], dim1D='cell_latlon' )
-            ATM_lon  = lmdz.geo2point ( 0*d_ATM_his ['lat_dom_out']+  d_ATM_his ['lon_dom_out'], dim1D='cell_latlon' )
-        ATM_aire = lmdz.geo2point ( d_ATM_aire ['aire'].squeeze(), cumulPoles=True, dim1D='cell_latlon' )
-        ATM_fter = lmdz.geo2point ( d_ATM_his ['fract_ter'][0], dim1D='cell_latlon' )
-        ATM_foce = lmdz.geo2point ( d_ATM_his ['fract_oce'][0], dim1D='cell_latlon' )
-        ATM_fsic = lmdz.geo2point ( d_ATM_his ['fract_sic'][0], dim1D='cell_latlon' )
-        ATM_flic = lmdz.geo2point ( d_ATM_his ['fract_lic'][0], dim1D='cell_latlon' )
+        echo ( 'ATM areas and fractions on latlon grid' )
+        if 'lat_dom_out' in d_ATM_his.variables :
+            ATM_lat  = lmdz.geo2point (   rprec (d_ATM_his ['lat_dom_out'])+0*rprec (d_ATM_his ['lon_dom_out']), dim1D='cell' )
+            ATM_lon  = lmdz.geo2point ( 0*rprec (d_ATM_his ['lat_dom_out'])+  rprec (d_ATM_his ['lon_dom_out']), dim1D='cell' )
+        else :
+            ATM_lat  = lmdz.geo2point (   rprec (d_ATM_his ['lat'])+0*rprec (d_ATM_his ['lon']), dim1D='cell' )
+            ATM_lon  = lmdz.geo2point ( 0*rprec (d_ATM_his ['lat'])+  rprec (d_ATM_his ['lon']), dim1D='cell' )
+        ATM_aire = lmdz.geo2point ( rprec (d_ATM_his ['aire'][0]).squeeze(), cumulPoles=True, dim1D='cell' )
+        ATM_fter = lmdz.geo2point ( rprec (d_ATM_his ['fract_ter'][0]), dim1D='cell' )
+        ATM_foce = lmdz.geo2point ( rprec (d_ATM_his ['fract_oce'][0]), dim1D='cell' )
+        ATM_fsic = lmdz.geo2point ( rprec (d_ATM_his ['fract_sic'][0]), dim1D='cell' )
+        ATM_flic = lmdz.geo2point ( rprec (d_ATM_his ['fract_lic'][0]), dim1D='cell' )
+
+    if ATM_HIS == 'ico' :
+        echo ( 'ATM areas and fractions on ICO grid' )
+        ATM_aire =  rprec (d_ATM_his ['aire']     [0])[ATM_his_keysort].squeeze()
+        ATM_lat  =  rprec (d_ATM_his ['lat']         )[ATM_his_keysort]
+        ATM_lon  =  rprec (d_ATM_his ['lon']         )[ATM_his_keysort]
+        ATM_fter =  rprec (d_ATM_his ['fract_ter'][0])[ATM_his_keysort]
+        ATM_foce =  rprec (d_ATM_his ['fract_oce'][0])[ATM_his_keysort]
+        ATM_fsic =  rprec (d_ATM_his ['fract_sic'][0])[ATM_his_keysort]
+        ATM_flic =  rprec (d_ATM_his ['fract_lic'][0])[ATM_his_keysort]
 
     if SRF_HIS == 'latlon' :
-        try :
-            SRF_lat  = lmdz.geo2point (   d_SRF_his ['lat']+0*d_SRF_his ['lon'], dim1D='cell_latlon' )
-            SRF_lon  = lmdz.geo2point ( 0*d_SRF_his ['lat']+  d_SRF_his ['lon'], dim1D='cell_latlon' )
-        except :
-            try : 
-                SRF_lat  = lmdz.geo2point (   d_SRF_his ['lat_dom_out']+0*d_SRF_his ['lon_dom_out'], dim1D='cell_latlon' )
-                SRF_lon  = lmdz.geo2point ( 0*d_SRF_his ['lat_dom_out']+  d_SRF_his ['lon_dom_out'], dim1D='cell_latlon' )
-            except : 
-                SRF_lat  = lmdz.geo2point (   d_SRF_his ['lat_domain_landpoints_out']+0*d_SRF_his ['lon_domain_landpoints_out'], dim1D='cell_latlon' )
-                SRF_lon  = lmdz.geo2point ( 0*d_SRF_his ['lat_domain_landpoints_out']+  d_SRF_his ['lon_domain_landpoints_out'], dim1D='cell_latlon' )
-        SRF_areas    = d_SRF_his ['Areas'].values
-        SRF_areafrac = d_SRF_his ['AreaFrac'].values
-        SRF_areas    = xr.DataArray ( SRF_areas   , coords=d_SRF_his ['Contfrac'].coords, dims=d_SRF_his ['Contfrac'].dims)
-        SRF_areafrac = xr.DataArray ( SRF_areafrac, coords=d_SRF_his ['Contfrac'].coords, dims=d_SRF_his ['Contfrac'].dims)
-
-        SRF_areas     = lmdz.geo2point ( SRF_areas   , dim1D='cell_latlon', cumulPoles=True )
-        SRF_areafrac  = lmdz.geo2point ( SRF_areafrac, dim1D='cell_latlon', cumulPoles=True )
-        SRF_contfrac  = SRF_areafrac / SRF_areas
-        SRF_aire      = SRF_areafrac
-
-    if ATM_HIS == 'ico' :
-        echo ( f'Grille icosaedre' )
-        ATM_aire =  d_ATM_his ['aire']     [0][ATM_his_keysort].squeeze()
-        ATM_lat  =  d_ATM_his ['lat']         [ATM_his_keysort]
-        ATM_lon  =  d_ATM_his ['lon']         [ATM_his_keysort]
-        ATM_fter =  d_ATM_his ['fract_ter'][0][ATM_his_keysort]
-        ATM_foce =  d_ATM_his ['fract_oce'][0][ATM_his_keysort]
-        ATM_fsic =  d_ATM_his ['fract_sic'][0][ATM_his_keysort]
-        ATM_flic =  d_ATM_his ['fract_lic'][0][ATM_his_keysort]
-        
-    if SRF_HIS == 'ico' : 
-        SRF_lat       =  d_SRF_his ['lat']      [SRF_his_keysort]
-        SRF_lon       =  d_SRF_his ['lon']      [SRF_his_keysort]
-        SRF_areas     =  d_SRF_his ['Areas']    [SRF_his_keysort] 
-        #SRF_areafrac =  d_SRF_his ['AreaFrac'] [SRF_his_keysort] 
-        SRF_contfrac  =  d_SRF_his ['Contfrac'][SRF_his_keysort]
+        echo ( 'SRF areas and fractions on latlon grid' )
+        if 'lat_domain_landpoints_out' in d_SRF_his  : 
+            SRF_lat  = lmdz.geo2point (   rprec (d_SRF_his ['lat_domain_landpoints_out'])+0*rprec (d_SRF_his ['lon_domain_landpoints_out']), dim1D='cell' )
+            SRF_lon  = lmdz.geo2point ( 0*rprec (d_SRF_his ['lat_domain_landpoints_out'])+  rprec (d_SRF_his ['lon_domain_landpoints_out']), dim1D='cell' )
+        else : 
+            if 'lat_domain_landpoints_out' in d_SRF_his :
+                SRF_lat  = lmdz.geo2point (   rprec (d_SRF_his ['lat_dom_out'])+0*rprec (d_SRF_his ['lon_dom_out']), dim1D='cell' )
+                SRF_lon  = lmdz.geo2point ( 0*rprec (d_SRF_his ['lat_dom_out'])+  rprec (d_SRF_his ['lon_dom_out']), dim1D='cell' )
+            else :
+                SRF_lat  = lmdz.geo2point (   rprec (d_SRF_his ['lat'])+0*rprec (d_SRF_his ['lon']), dim1D='cell' )
+                SRF_lon  = lmdz.geo2point ( 0*rprec (d_SRF_his ['lat'])+  rprec (d_SRF_his ['lon']), dim1D='cell' )
+                
+        SRF_areas     = lmdz.geo2point ( rprec (d_SRF_his ['Areas']   )   , dim1D='cell', cumulPoles=True )
+        SRF_areafrac  = lmdz.geo2point ( rprec (d_SRF_his ['AreaFrac'])   , dim1D='cell', cumulPoles=True )
+        SRF_contfrac  = lmdz.geo2point ( rprec (d_SRF_his ['Contfrac'])   , dim1D='cell', cumulPoles=True )
+        SRF_aire = SRF_areafrac
+ 
+    if SRF_HIS == 'ico' :
+        echo ( 'SRF areas and fractions on latlon grid' )
+        SRF_lat       =  rprec (d_SRF_his ['lat']     ) [SRF_his_keysort]
+        SRF_lon       =  rprec (d_SRF_his ['lon']     ) [SRF_his_keysort]
+        SRF_areas     =  rprec (d_SRF_his ['Areas']   ) [SRF_his_keysort] 
+        SRF_contfrac  =  rprec (d_SRF_his ['Contfrac']) [SRF_his_keysort]
         SRF_aire      =  SRF_areas * SRF_contfrac
 
@@ -681,5 +728,5 @@
 ATM_aire_fsea = ATM_aire * ATM_fsea
 
-SRF_aire = SRF_aire.where ( np.abs (SRF_aire) < 1E15, 0. )
+#SRF_aire = SRF_aire.where ( np.abs (SRF_aire) < 1E15, 0. )
 
 ## Write the full configuration
@@ -713,6 +760,6 @@
     DYN_fsea = ATM_fsea
     DYN_flnd = ATM_flnd
-    DYN_fter = d_ATM_beg['FTER']
-    DYN_flic = d_ATM_beg['FLIC']
+    DYN_fter = rprec (d_ATM_beg['FTER'])
+    DYN_flic = rprec (d_ATM_beg['FLIC'])
     DYN_aire_fter = DYN_aire * DYN_fter
 
@@ -728,4 +775,9 @@
     return ATM_flux_int
 
+def LIC_flux_int (flux) :
+    '''Integrate (* time * surface) flux on land ice grid'''
+    LIC_flux_int  = wu.Psum ( (flux * dtime_per_sec * ATM_aire_flic).to_masked_array().ravel() )
+    return LIC_flux_int
+
 def SRF_stock_int (stock) :
     '''Integrate (* surface) stock on land grid'''
@@ -749,19 +801,29 @@
     return ONE_flux_int
 
+def Sprec ( tlist ) :
+    '''Accurate sum of list of scalar elements'''
+    return wu.Psum ( np.array ( tlist) )
+
 ATM_aire_sea     = ATM_aire * ATM_fsea
+
 ATM_aire_tot     = ONE_stock_int (ATM_aire)
-ATM_aire_sea_tot = ONE_stock_int (ATM_aire*ATM_fsea)
-
-DYN_aire_tot     =  ONE_stock_int ( DYN_aire )
-SRF_aire_tot     =  ONE_stock_int ( SRF_aire )
+ATM_aire_sea_tot = ONE_stock_int (ATM_aire_fsea)
+ATM_aire_ter_tot = ONE_stock_int (ATM_aire_fter)
+ATM_aire_lic_tot = ONE_stock_int (ATM_aire_flic)
+
+DYN_aire_tot     = ONE_stock_int ( DYN_aire )
+SRF_aire_tot     = ONE_stock_int ( SRF_aire )
 
 echo ('')
-echo ( f'ATM DYN : Area of atmosphere : {DYN_aire_tot:18.9e}' )
-echo ( f'ATM HIS : Area of atmosphere : {ATM_aire_tot:18.9e}' )
-echo ( f'ATM SRF : Area of atmosphere : {SRF_aire_tot:18.9e}' )
+echo ( f'ATM DYN : Area of atmosphere        : {DYN_aire_tot:18.9e}' )
+echo ( f'ATM HIS : Area of atmosphere        : {ATM_aire_tot:18.9e}' )
+echo ( f'ATM HIS : Area of ter in atmosphere : {ATM_aire_ter_tot:18.9e}' )
+echo ( f'ATM HIS : Area of lic in atmosphere : {ATM_aire_lic_tot:18.9e}' )
+echo ( f'ATM SRF : Area of atmosphere        : {SRF_aire_tot:18.9e}' )
 echo ('')
-echo ( 'ATM DYN : Area of atmosphere/(4pi R^2) : {:18.9f}'.format(DYN_aire_tot/(Ra*Ra*4*np.pi) ) )
-echo ( 'ATM HIS : Area of atmosphere/(4pi R^2) : {:18.9f}'.format(ATM_aire_tot/(Ra*Ra*4*np.pi) ) )
-echo ( 'ATM SRF : Area of atmosphere/(4pi R^2) : {:18.9f}'.format(SRF_aire_tot/(Ra*Ra*4*np.pi) ) )
+echo ( 'ATM DYN : Area of atmosphere/(4pi R^2)        : {:18.9f}'.format(DYN_aire_tot/(Ra*Ra*4*np.pi) ) )
+echo ( 'ATM HIS : Area of atmosphere/(4pi R^2)        : {:18.9f}'.format(ATM_aire_tot/(Ra*Ra*4*np.pi) ) )
+echo ( 'ATM HIS : Area of ter in atmosphere/(4pi R^2) : {:18.9f}'.format(ATM_aire_ter_tot/(Ra*Ra*4*np.pi) ) )
+echo ( 'ATM SRF : Area of atmosphere/(4pi R^2)        : {:18.9f}'.format(SRF_aire_tot/(Ra*Ra*4*np.pi) ) )
 echo ('')
 echo ( f'ATM SRF : Area of atmosphere (no contfrac): {ONE_stock_int (SRF_areas):18.9e}' )
@@ -786,6 +848,6 @@
     DYN_psol_end = d_DYN_end['ps'][DYN_end_keysort]
 if LMDZ : 
-    DYN_psol_beg = lmdz.geo2point ( d_DYN_beg['ps'].isel(rlonv=slice(0,-1)), dim1D='cell_latlon' )
-    DYN_psol_end = lmdz.geo2point ( d_DYN_end['ps'].isel(rlonv=slice(0,-1)), dim1D='cell_latlon' )
+    DYN_psol_beg = lmdz.geo2point ( d_DYN_beg['ps'].isel(rlonv=slice(0,-1)), dim1D='cell' )
+    DYN_psol_end = lmdz.geo2point ( d_DYN_end['ps'].isel(rlonv=slice(0,-1)), dim1D='cell' )
     
 echo ( '3D Pressure at the interface layers (not scalar points)' )
@@ -793,4 +855,29 @@
 DYN_pres_end = ATM_Ahyb + ATM_Bhyb * DYN_psol_end
 
+echo ( 'Check computation of pressure levels' )
+
+ind = np.empty (8)
+
+ind[0] = (DYN_pres_beg[ 0]-DYN_psol_beg).min().item()
+ind[1] = (DYN_pres_beg[ 0]-DYN_psol_beg).max().item()
+ind[2] = (DYN_pres_beg[-1]).min().item()
+ind[3] = (DYN_pres_beg[-1]).max().item()
+ind[4] = (DYN_pres_end[ 0]-DYN_psol_end).min().item()
+ind[5] = (DYN_pres_end[ 0]-DYN_psol_end).max().item()
+ind[6] = (DYN_pres_end[-1]).min().item()
+ind[7] = (DYN_pres_end[-1]).max().item()
+
+if any ( ind != 0) :
+    echo ( 'All values should be zero' )
+    echo ( f'(DYN_pres_beg[ 0]-DYN_psol_beg).min().item() = {ind[0]}' )
+    echo ( f'(DYN_pres_beg[ 0]-DYN_psol_beg).max().item() = {ind[1]}' )
+    echo ( f'(DYN_pres_beg[-1]).min().item()              = {ind[2]}' )
+    echo ( f'(DYN_pres_beg[-1]).max().item()              = {ind[3]}' )
+    echo ( f'(DYN_pres_end[ 0]-DYN_psol_end).min().item() = {ind[4]}' )
+    echo ( f'(DYN_pres_end[ 0]-DYN_psol_end).max().item() = {ind[5]}' )
+    echo ( f'(DYN_pres_end[-1]).min().item()              = {ind[6]}' )
+    echo ( f'(DYN_pres_end[-1]).max().item()              = {ind[7]}' )
+    raise Exception
+    
 klevp1 = ATM_Bhyb.shape[-1]
 cell   = DYN_psol_beg.shape[-1]
@@ -798,44 +885,60 @@
 
 echo ( 'Layer thickness (pressure)' )
-DYN_dpres_beg = xr.DataArray ( np.empty( (klev, cell )), dims = ('sigs', 'cell'), coords=(np.arange(klev), np.arange(cell) ) )
-DYN_dpres_end = xr.DataArray ( np.empty( (klev, cell )), dims = ('sigs', 'cell'), coords=(np.arange(klev), np.arange(cell) ) )
-    
-for k in np.arange (klevp1-1) :
-    DYN_dpres_beg[k,:] = DYN_pres_beg[k,:] - DYN_pres_beg[k+1,:]
-    DYN_dpres_end[k,:] = DYN_pres_end[k,:] - DYN_pres_end[k+1,:]
+DYN_mass_beg = xr.DataArray ( np.empty( (klev, cell)), dims = ('sigs', 'cell'), coords=(np.arange(klev), np.arange(cell) ) )
+DYN_mass_end = xr.DataArray ( np.empty( (klev, cell)), dims = ('sigs', 'cell'), coords=(np.arange(klev), np.arange(cell) ) )
+    
+for k in np.arange (klev) :
+    DYN_mass_beg[k,:] = ( DYN_pres_beg[k,:] - DYN_pres_beg[k+1,:] ) / Grav
+    DYN_mass_end[k,:] = ( DYN_pres_end[k,:] - DYN_pres_end[k+1,:] ) / Grav
+
+DYN_mass_beg_2D = DYN_mass_beg.sum (dim='sigs')
+DYN_mass_end_2D = DYN_mass_end.sum (dim='sigs')
+
+DYN_mas_air_beg = DYN_stock_int ( DYN_mass_beg_2D )
+DYN_mas_air_end = DYN_stock_int ( DYN_mass_end_2D )
 
 echo ( 'Vertical and horizontal integral, and sum of liquid, solid and vapor water phases' )
 if LMDZ :
-    try : 
-        DYN_wat_beg = lmdz.geo3point ( (d_DYN_beg['H2Ov']  + d_DYN_beg['H2Ol']  + d_DYN_beg['H2Oi'] ).isel(rlonv=slice(0,-1) ), dim1D='cell' )
-        DYN_wat_end = lmdz.geo3point ( (d_DYN_end['H2Ov']  + d_DYN_end['H2Ol']  + d_DYN_end['H2Oi'] ).isel(rlonv=slice(0,-1) ), dim1D='cell' )
-    except :
+    if 'H2Ov' in d_DYN_beg.variables :
+        echo ('reading LATLON : H2Ov, H2Ol, H2Oi' )
+        DYN_wat_beg = lmdz.geo3point ( d_DYN_beg['H2Ov'] + d_DYN_beg['H2Ol'] + d_DYN_beg['H2Oi'].isel(rlonv=slice(0,-1) ), dim1D='cell' )
+        DYN_wat_end = lmdz.geo3point ( d_DYN_end['H2Ov'] + d_DYN_end['H2Ol'] + d_DYN_end['H2Oi'].isel(rlonv=slice(0,-1) ), dim1D='cell' )
+    if 'H2Ov_g' in d_DYN_beg.variables :
+        echo ('reading LATLON : H2O_g, H2O_l, H2O_s' )
         DYN_wat_beg = lmdz.geo3point ( (d_DYN_beg['H2O_g'] + d_DYN_beg['H2O_l'] + d_DYN_beg['H2O_s']).isel(rlonv=slice(0,-1) ), dim1D='cell' )
         DYN_wat_end = lmdz.geo3point ( (d_DYN_end['H2O_g'] + d_DYN_end['H2O_l'] + d_DYN_end['H2O_s']).isel(rlonv=slice(0,-1) ), dim1D='cell' )
 if ICO :
-    try :
+    if 'H2Ov_g' in d_DYN_beg.variables :
+        echo ('reading ICO : H2O_g, H2O_l, H2O_s' )
         DYN_wat_beg = (d_DYN_beg['H2O_g'] + d_DYN_beg['H2O_l'] + d_DYN_beg['H2O_s'])[..., DYN_beg_keysort]
         DYN_wat_end = (d_DYN_end['H2O_g'] + d_DYN_end['H2O_l'] + d_DYN_end['H2O_s'])[..., DYN_beg_keysort]
-        
-    except : 
+    elif 'H2O_g' in d_DYN_beg.variables :
+        echo ('reading ICO : H2O_g, H2O_l, H2O_s' )
+        DYN_wat_beg = (d_DYN_beg['H2O_g'] + d_DYN_beg['H2O_l'] + d_DYN_beg['H2O_s'])[..., DYN_beg_keysort]
+        DYN_wat_end = (d_DYN_end['H2O_g'] + d_DYN_end['H2O_l'] + d_DYN_end['H2O_s'])[..., DYN_beg_keysort]
+    elif 'q' in d_DYN_beg.variables :
+        echo ('reading ICO : q' )
         DYN_wat_beg = (d_DYN_beg['q'].isel(nq=0) + d_DYN_beg['q'].isel(nq=1) + d_DYN_beg['q'].isel(nq=2) )[..., DYN_beg_keysort]
         DYN_wat_end = (d_DYN_end['q'].isel(nq=0) + d_DYN_end['q'].isel(nq=1) + d_DYN_end['q'].isel(nq=2) )[..., DYN_beg_keysort]
-        
+
+if 'lev' in DYN_wat_beg.dims : 
     DYN_wat_beg = DYN_wat_beg.rename ( {'lev':'sigs'} )
-    DYN_wat_beg = DYN_wat_end.rename ( {'lev':'sigs'} )
+    DYN_wat_end = DYN_wat_end.rename ( {'lev':'sigs'} )
     
 echo ( 'Compute water content : vertical and horizontal integral' )
-DYN_mas_wat_beg = DYN_stock_int ( (DYN_dpres_beg * DYN_wat_beg).sum (dim='sigs') ) / Grav
-DYN_mas_wat_end = DYN_stock_int ( (DYN_dpres_end * DYN_wat_end).sum (dim='sigs') ) / Grav
+
+DYN_wat_beg_2D =  (DYN_mass_beg * DYN_wat_beg).sum (dim='sigs')
+DYN_wat_end_2D =  (DYN_mass_end * DYN_wat_end).sum (dim='sigs')
+
+DYN_mas_wat_beg = DYN_stock_int ( DYN_wat_beg_2D )
+DYN_mas_wat_end = DYN_stock_int ( DYN_wat_end_2D )
 
 echo ( 'Variation of water content' )
 dDYN_mas_wat = DYN_mas_wat_end - DYN_mas_wat_beg
 
-# \([a-z,A-Z,_]*\)/dtime_sec\*1e-9  kg2Sv(\1)
-# \([a-z,A-Z,_]*\)\/ATM_aire_sea_tot\/ATM_rho\/NbYear  kg2myear(\1)
-
 echo ( f'\nChange of atmosphere water content (dynamics)  -- {Title} ' )
 echo ( '------------------------------------------------------------------------------------' )
-echo ( 'DYN_mas_beg = {:12.6e} kg | DYN_mas_end = {:12.6e} kg'.format (DYN_mas_wat_beg, DYN_mas_wat_end) )
+echo ( 'DYN_mas_air_beg = {:12.6e} kg | DYN_mas_air_end = {:12.6e} kg'.format (DYN_mas_air_beg, DYN_mas_air_end) )
+echo ( 'DYN_mas_wat_beg = {:12.6e} kg | DYN_mas_wat_end = {:12.6e} kg'.format (DYN_mas_wat_beg, DYN_mas_wat_end) )
 prtFlux ( 'dMass (atm)  ', dDYN_mas_wat, 'e', True )
 
@@ -850,6 +953,6 @@
               d_ATM_end['QS03']  *d_ATM_end['FOCE'] + d_ATM_end['QS04']  *d_ATM_end['FSIC']
 
-ATM_qsol_beg = d_ATM_beg['QSOL']
-ATM_qsol_end = d_ATM_end['QSOL']
+ATM_qsol_beg     = d_ATM_beg['QSOL']
+ATM_qsol_end     = d_ATM_end['QSOL']
 
 LIC_sno_beg      = d_ATM_beg['SNOW02']*d_ATM_beg['FLIC']
@@ -859,32 +962,33 @@
 LIC_runlic0_end  = d_ATM_end['RUNOFFLIC0']
 
-ATM_qs01_beg  = d_ATM_beg['QS01'] * d_ATM_beg['FTER']
-ATM_qs01_end  = d_ATM_end['QS01'] * d_ATM_end['FTER']
-ATM_qs02_beg  = d_ATM_beg['QS02'] * d_ATM_beg['FLIC']
-ATM_qs02_end  = d_ATM_end['QS02'] * d_ATM_end['FLIC']
-ATM_qs03_beg  = d_ATM_beg['QS03'] * d_ATM_beg['FOCE']
-ATM_qs03_end  = d_ATM_end['QS03'] * d_ATM_end['FOCE']
-ATM_qs04_beg  = d_ATM_beg['QS04'] * d_ATM_beg['FSIC']
-ATM_qs04_end  = d_ATM_end['QS04'] * d_ATM_end['FSIC']  
+ATM_qs01_beg     = d_ATM_beg['QS01'] * d_ATM_beg['FTER']
+ATM_qs02_beg     = d_ATM_beg['QS02'] * d_ATM_beg['FLIC']
+ATM_qs03_beg     = d_ATM_beg['QS03'] * d_ATM_beg['FOCE']
+ATM_qs04_beg     = d_ATM_beg['QS04'] * d_ATM_beg['FSIC']
+
+ATM_qs01_end     = d_ATM_end['QS01'] * d_ATM_end['FTER']
+ATM_qs02_end     = d_ATM_end['QS02'] * d_ATM_end['FLIC']
+ATM_qs03_end     = d_ATM_end['QS03'] * d_ATM_end['FOCE']
+ATM_qs04_end     = d_ATM_end['QS04'] * d_ATM_end['FSIC']  
 
 if ICO :
-     ATM_sno_beg       = ATM_sno_beg    [ATM_beg_keysort]
-     ATM_sno_end       = ATM_sno_end    [ATM_end_keysort]
-     ATM_qs_beg        = ATM_qs_beg     [ATM_beg_keysort]
-     ATM_qs_end        = ATM_qs_end     [ATM_end_keysort]
-     ATM_qsol_beg      = ATM_qsol_beg   [ATM_beg_keysort]
-     ATM_qsol_end      = ATM_qsol_end   [ATM_end_keysort]
-     ATM_qs01_beg      = ATM_qs01_beg   [ATM_beg_keysort]
-     ATM_qs01_end      = ATM_qs01_end   [ATM_end_keysort]
-     ATM_qs02_beg      = ATM_qs02_beg   [ATM_beg_keysort]
-     ATM_qs02_end      = ATM_qs02_end   [ATM_end_keysort]
-     ATM_qs03_beg      = ATM_qs03_beg   [ATM_beg_keysort]
-     ATM_qs03_end      = ATM_qs03_end   [ATM_end_keysort]
-     ATM_qs04_beg      = ATM_qs04_beg   [ATM_beg_keysort]
-     ATM_qs04_end      = ATM_qs04_end   [ATM_end_keysort]
-     LIC_sno_beg       = LIC_sno_beg    [ATM_beg_keysort]
-     LIC_sno_end       = LIC_sno_end    [ATM_end_keysort]
-     LIC_runlic0_beg   = LIC_runlic0_beg[ATM_beg_keysort]
-     LIC_runlic0_end   = LIC_runlic0_end[ATM_end_keysort]
+     ATM_sno_beg     = ATM_sno_beg    [ATM_beg_keysort]
+     ATM_sno_end     = ATM_sno_end    [ATM_end_keysort]
+     ATM_qs_beg      = ATM_qs_beg     [ATM_beg_keysort]
+     ATM_qs_end      = ATM_qs_end     [ATM_end_keysort]
+     ATM_qsol_beg    = ATM_qsol_beg   [ATM_beg_keysort]
+     ATM_qs01_beg    = ATM_qs01_beg   [ATM_beg_keysort]
+     ATM_qs02_beg    = ATM_qs02_beg   [ATM_beg_keysort]
+     ATM_qs03_beg    = ATM_qs03_beg   [ATM_beg_keysort]
+     ATM_qs04_beg    = ATM_qs04_beg   [ATM_beg_keysort]
+     ATM_qsol_end    = ATM_qsol_end   [ATM_end_keysort]
+     ATM_qs01_end    = ATM_qs01_end   [ATM_end_keysort]
+     ATM_qs02_end    = ATM_qs02_end   [ATM_end_keysort]
+     ATM_qs03_end    = ATM_qs03_end   [ATM_end_keysort]
+     ATM_qs04_end    = ATM_qs04_end   [ATM_end_keysort]
+     LIC_sno_beg     = LIC_sno_beg    [ATM_beg_keysort]
+     LIC_sno_end     = LIC_sno_end    [ATM_end_keysort]
+     LIC_runlic0_beg = LIC_runlic0_beg[ATM_beg_keysort]
+     LIC_runlic0_end = LIC_runlic0_end[ATM_end_keysort]
    
 LIC_qs_beg = ATM_qs02_beg
@@ -897,12 +1001,12 @@
 ATM_mas_qs_end      = DYN_stock_int ( ATM_qs_end   )
 ATM_mas_qsol_beg    = DYN_stock_int ( ATM_qsol_beg )
+ATM_mas_qs01_beg    = DYN_stock_int ( ATM_qs01_beg )
+ATM_mas_qs02_beg    = DYN_stock_int ( ATM_qs02_beg )
+ATM_mas_qs03_beg    = DYN_stock_int ( ATM_qs03_beg )
+ATM_mas_qs04_beg    = DYN_stock_int ( ATM_qs04_beg )
 ATM_mas_qsol_end    = DYN_stock_int ( ATM_qsol_end )
-ATM_mas_qs01_beg    = DYN_stock_int ( ATM_qs01_beg )
 ATM_mas_qs01_end    = DYN_stock_int ( ATM_qs01_end )
-ATM_mas_qs02_beg    = DYN_stock_int ( ATM_qs02_beg )
 ATM_mas_qs02_end    = DYN_stock_int ( ATM_qs02_end )
-ATM_mas_qs03_beg    = DYN_stock_int ( ATM_qs03_beg )
 ATM_mas_qs03_end    = DYN_stock_int ( ATM_qs03_end )
-ATM_mas_qs04_beg    = DYN_stock_int ( ATM_qs04_beg )
 ATM_mas_qs04_end    = DYN_stock_int ( ATM_qs04_end )
 
@@ -929,5 +1033,6 @@
 dLIC_mas_sno     = LIC_mas_sno_end     - LIC_mas_sno_beg
 dLIC_mas_runlic0 = LIC_mas_runlic0_end - LIC_mas_runlic0_beg
-dLIC_mas_wat     = dLIC_mas_qs + dLIC_mas_sno
+
+dLIC_mas_wat     = dLIC_mas_qs + dLIC_mas_sno # + dLIC_mas_runlic0
 
 echo ( f'\nChange of atmosphere snow content (Land ice) -- {Title} ' )
@@ -980,8 +1085,9 @@
     RUN_mas_wat_pond_end   = ONE_stock_int ( d_SRF_end ['pondres']   )
 
-RUN_mas_wat_beg = RUN_mas_wat_fast_beg  + RUN_mas_wat_slow_beg + RUN_mas_wat_stream_beg + \
-                  RUN_mas_wat_flood_beg + RUN_mas_wat_lake_beg + RUN_mas_wat_pond_beg
-RUN_mas_wat_end = RUN_mas_wat_fast_end  + RUN_mas_wat_slow_end + RUN_mas_wat_stream_end + \
-                  RUN_mas_wat_flood_end + RUN_mas_wat_lake_end + RUN_mas_wat_pond_end
+RUN_mas_wat_beg = Sprec ( [RUN_mas_wat_fast_beg , RUN_mas_wat_slow_beg, RUN_mas_wat_stream_beg,
+                           RUN_mas_wat_flood_beg, RUN_mas_wat_lake_beg, RUN_mas_wat_pond_beg] )
+                  
+RUN_mas_wat_end = Sprec ( [RUN_mas_wat_fast_end  , RUN_mas_wat_slow_end , RUN_mas_wat_stream_end,
+                           RUN_mas_wat_flood_end , RUN_mas_wat_lake_end , RUN_mas_wat_pond_end] )
 
 dRUN_mas_wat_fast   = RUN_mas_wat_fast_end   - RUN_mas_wat_fast_beg
